#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="97.000000" y="72.000000">
      <Parameter name="LENGTH" type="subnet_param" value="int:ARG2" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="int:ARG3" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
      <Parameter name="FBANK_COUNT1" type="subnet_param" value="int:ARG6" description="The number of static components of the input feature vector."/>
      <Parameter name="FBANK_COUNT" type="subnet_param" value="int:ARG5" description="Number of filter banks of an input spectrum."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="int:ARG4" description="Sampling rate (Hz)."/>
    </Node>
    <Node name="node_Constant_1" type="Constant" x="-131.000000" y="72.000000">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="-25.000000" y="72.000000">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_MAIN_LOOP_1" input="IN"/>
    <NetOutput name="OUT" node="node_MAIN_LOOP_1" terminal="OUT" object_type="any" description="No description available"/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="45.000000" y="-13.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="USE_WAIT" type="bool" value="false" description="If true, real recording is simulated [default: false]."/>
    </Node>
    <Node name="node_MultiFFT_1" type="MultiFFT" x="315.000000" y="-20.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_MelFilterBank_1" type="MelFilterBank" x="474.000000" y="66.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="CUTOFF" type="int" value="8000" description="Cutoff frequency. A frequency band between 0Hz to the cutoff frequency is used for calculation."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="63" description="Minimum frequency (Hz) [default: 63]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="8000" description="Maximum frequency (Hz) [default: 8000]"/>
      <Parameter name="FBANK_COUNT" type="subnet_param" value="FBANK_COUNT" description="The number of filter banks."/>
    </Node>
    <Node name="node_MatrixToMap_1" type="MatrixToMap" x="430.000000" y="-20.000000"/>
    <Node name="node_SaveFeatures_1" type="SaveFeatures" x="452.000000" y="238.000000">
      <Parameter name="BASENAME" type="string" value="MFBANK27_" description="Base name for save file names."/>
    </Node>
    <Node name="node_PowerCalcForMap_1" type="PowerCalcForMap" x="338.000000" y="66.000000"/>
    <Node name="node_MSLSExtraction_1" type="MSLSExtraction" x="101.000000" y="145.000000">
      <Parameter name="FBANK_COUNT" type="subnet_param" value="FBANK_COUNT" description="Number of filter banks of an input spectrum."/>
      <Parameter name="NORMALIZATION_MODE" type="string" value="CEPSTRAL" description="The domain in which normalization is performed. CEPSTRAL or SPECTRAL."/>
      <Parameter name="USE_POWER" type="bool" value="true" description="Use power feature if true."/>
    </Node>
    <Node name="node_Delta_1" type="Delta" x="483.000000" y="153.000000">
      <Parameter name="FBANK_COUNT" type="subnet_param" value="FBANK_COUNT1" description="The number of static components of the input feature vector."/>
    </Node>
    <Node name="node_FeatureRemover_1" type="FeatureRemover" x="247.000000" y="230.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 13 &gt;" description="Set indices of a feature vector to remove like &lt;Vector&lt;int&gt; 13&gt;."/>
    </Node>
    <Node name="node_PreEmphasis_1" type="PreEmphasis" x="120.000000" y="66.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="window length in sample [default: 512]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate in Hz [default: 16000]"/>
      <Parameter name="PREEMCOEF" type="float" value="0.97" description="pre-emphasis coefficient [default: 0.97]"/>
      <Parameter name="INPUT_TYPE" type="string" value="WAV" description="The domain to perform pre-emphasis [default: WAV]"/>
    </Node>
    <Node name="node_Synthesize_1" type="Synthesize" x="9.000000" y="66.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, or RECTANGLE. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1.0" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_MultiFFT_2" type="MultiFFT" x="222.000000" y="66.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_SpectralMeanNormalization_1" type="SpectralMeanNormalization" x="343.000000" y="153.000000">
      <Parameter name="FBANK_COUNT" type="subnet_param" value="FBANK_COUNT1" description="Size of a static part of a feature vector. [default: 13]"/>
    </Node>
    <Node name="node_ConstantLocalization_1" type="ConstantLocalization" x="43.000000" y="229.000000">
      <Parameter name="ANGLES" type="object" value="&lt;Vector&lt;float&gt; 0 &gt;" description="A vector to specify source locations. Each vector element shows azimuth of a source in degree."/>
      <Parameter name="ELEVATIONS" type="object" value="&lt;Vector&lt;float&gt; 0 &gt;" description="Elevations of source locations. Each element represents an elevation of each source location."/>
    </Node>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_MatrixToMap_1" input="INPUT"/>
    <Link from="node_PowerCalcForMap_1" output="OUTPUT" to="node_MelFilterBank_1" input="INPUT"/>
    <Link from="node_MelFilterBank_1" output="OUTPUT" to="node_MSLSExtraction_1" input="FBANK">522 66 533 66 533 100 -51 100 -51 138 -28 137.5 </Link>
    <Link from="node_Delta_1" output="OUTPUT" to="node_FeatureRemover_1" input="INPUT">504.5 153 529 153 529 204 173 204 173 230 193 230 </Link>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_PreEmphasis_1" input="INPUT"/>
    <Link from="node_MatrixToMap_1" output="OUTPUT" to="node_Synthesize_1" input="INPUT">476 -20 532 -20 532 30 -51 30 -51 66 -28.5 66 </Link>
    <Link from="node_PreEmphasis_1" output="OUTPUT" to="node_MultiFFT_2" input="INPUT"/>
    <Link from="node_MultiFFT_2" output="OUTPUT" to="node_PowerCalcForMap_1" input="INPUT"/>
    <Link from="node_MultiFFT_2" output="OUTPUT" to="node_MSLSExtraction_1" input="SPECTRUM">254.5 66 262 67 263 112 -43 112 -43 152 -28 152.5 </Link>
    <Link from="node_MSLSExtraction_1" output="OUTPUT" to="node_SpectralMeanNormalization_1" input="FBANK"/>
    <Link from="node_FeatureRemover_1" output="OUTPUT" to="node_SaveFeatures_1" input="FEATURES"/>
    <Link from="node_ConstantLocalization_1" output="SOURCES" to="node_SpectralMeanNormalization_1" input="SOURCES">113.5 229 165 229 165 160 185 160.5 </Link>
    <Link from="node_ConstantLocalization_1" output="SOURCES" to="node_SaveFeatures_1" input="SOURCES">113.5 229 165 229 165 261 319 261 319 246 337 245.5 </Link>
    <Link from="node_SpectralMeanNormalization_1" output="OUTPUT" to="node_Delta_1" input="INPUT"/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetInput name="IN" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetOutput name="OUT" node="node_SaveFeatures_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as FEATURE."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="ARG1" type="" value=""/>
</Document>
