#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="51.000000" y="71.000000">
      <Parameter name="LENGTH" type="int" value="512" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="SPEED_OF_SOUND" type="float" value="343.0" description="Speed of sound (m/s)."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling Rate (Hz)."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="ARG2" description="Filename of a transfer function matrix."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="FILENAME" type="subnet_param" value="ARG3" description="The file name for saving source locations."/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <Node name="node_Constant_1" type="Constant" x="-195.000000" y="71.000000">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="-74.000000" y="71.000000">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_MAIN_LOOP_1" input="IN"/>
    <NetOutput name="SAVE" node="node_MAIN_LOOP_1" terminal="SAVE" object_type="any" description="No description available"/>
    <NetOutput name="DISP" node="node_MAIN_LOOP_1" terminal="DISP" object_type="any" description="No description available"/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="180.000000" y="91.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_LocalizeMUSIC_1" type="LocalizeMUSIC" x="303.000000" y="91.000000">
      <Parameter name="NB_CHANNELS" type="int" value="8" description="The number of input channels."/>
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame (per channel)."/>
      <Parameter name="SPEED_OF_SOUND" type="subnet_param" value="SPEED_OF_SOUND" description="Speed of sound (m/s)."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling Rate (Hz)."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="A_MATRIX" description="Filename of a transfer function matrix."/>
      <Parameter name="ELEVATION" type="float" value="0" description="An angle of elevation of source locations."/>
      <Parameter name="PERIOD" type="int" value="50" description="The number of frames used for calculating a correlation function."/>
      <Parameter name="NUM_SOURCE" type="int" value="1" description="Number of sources, which should be less than number of channels."/>
      <Parameter name="MIN_DEG" type="int" value="-180" description="source direction (lower)."/>
      <Parameter name="MAX_DEG" type="int" value="180" description="source direction (higher)."/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="500" description="Lower bound of frequency (Hz) used for correlation function calculation."/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="2800" description="Upper bound of frequency (Hz) used for correlation function calculation."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If the parameter is true, this node outputs sound localization results to a standard output."/>
    </Node>
    <Node name="node_SourceTracker_1" type="SourceTracker" x="-115.000000" y="172.000000">
      <Parameter name="THRESH" type="float" value="24" description="Threshold of a power of Source. When the power is less than the threshold, the source is deleted."/>
      <Parameter name="PAUSE_LENGTH" type="float" value="800" description="pause length."/>
      <Parameter name="MIN_SRC_INTERVAL" type="float" value="30" description="Threshold of a source interval. When an angle between two sources are smaller than MIN_SRC_INTERVAL, the sources are given the same ID."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Output debug information if true [default: false]"/>
    </Node>
    <Node name="node_DisplayLocalization_1" type="DisplayLocalization" x="235.000000" y="172.000000"/>
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="-95.000000" y="98.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="USE_WAIT" type="bool" value="false" description="If true, real recording is simulated [default: false]."/>
    </Node>
    <Node name="node_SourceIntervalExtender_1" type="SourceIntervalExtender" x="46.000000" y="172.000000">
      <Parameter name="PREROLL_LENGTH" type="int" value="0" description="The start of the source interval is extended forward by preroll length."/>
    </Node>
    <Node name="node_SaveSourceLocation_1" type="SaveSourceLocation" x="234.000000" y="230.000000">
      <Parameter name="FILENAME" type="subnet_param" value="FILENAME" description="The file name for saving source locations."/>
    </Node>
    <Link from="node_LocalizeMUSIC_1" output="OUTPUT" to="node_SourceTracker_1" input="INPUT">354.5 91 382 91 382 140 -211 140 -211 172 -164.5 172 </Link>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_DisplayLocalization_1" input="SOURCES"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_LocalizeMUSIC_1" input="INPUT"/>
    <Link from="node_SourceTracker_1" output="OUTPUT" to="node_SourceIntervalExtender_1" input="SOURCES"/>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_SaveSourceLocation_1" input="SOURCES">122.5 172 139 172 139 230 166.5 230 </Link>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetInput name="IN" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetOutput name="SAVE" node="node_SaveSourceLocation_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as input."/>
    <NetOutput name="DISP" node="node_DisplayLocalization_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as input."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="ARG2" type="" value=""/>
  <Parameter name="ARG3" type="" value=""/>
  <Parameter name="ARG1" type="" value=""/>
</Document>
