#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="-26.000000" y="172.000000">
      <Parameter name="LENGTH" type="int" value="512" description="The length of a frame (per channel)."/>
      <Parameter name="ADVANCE" type="int" value="160" description="Advance."/>
      <Parameter name="WN_LEVEL" type="float" value="300" description="An amplitude of white noise."/>
      <Parameter name="LX" type="float" value="0.5" description="Lx value of estimation, e.g. Lx=0 -&gt; Minimum (MCRA), Lx=0.5 -&gt; Median , Lx=1.0 -&gt; Maximum [default:0.85]"/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling Rate (Hz)"/>
      <Parameter name="TF_CONJ" type="subnet_param" value="string:ARG3" description="Filename of a pre-measured transfer function for separation."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="string:ARG2" description="Filename of a transfer function matrix."/>
      <Parameter name="NUM_SOURCE" type="int" value="3" description="Number of sources, which should be less than NB_CHANNELS [default: 2]."/>
      <Parameter name="THRESH" type="float" value="29.5" description="Power threshold for localization results. A localization result with higher power than THRESH is tracked, otherwise ignored."/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <Node name="node_Constant_1" type="Constant" x="-327.000000" y="172.000000">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="-181.000000" y="172.000000">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_MAIN_LOOP_1" input="INPUT"/>
    <NetOutput name="ASR" node="node_MAIN_LOOP_1" terminal="ASR" object_type="any" description="No description available"/>
    <NetOutput name="SAVE_SEP_GHDSS" node="node_MAIN_LOOP_1" terminal="SAVE_SEP_GHDSS" object_type="any" description="No description available"/>
    <NetOutput name="SAVE_SEP_WN" node="node_MAIN_LOOP_1" terminal="SAVE_SEP_WN" object_type="any" description="No description available"/>
    <NetOutput name="SAVE_SEP_NOISE_REDUCTION" node="node_MAIN_LOOP_1" terminal="SAVE_SEP_NOISE_REDUCTION" object_type="any" description="No description available"/>
    <NetOutput name="OUTPUT" node="node_MAIN_LOOP_1" terminal="OUTPUT" object_type="any" description="No description available"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="-31.000000" y="-279.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be &quot;CONJ&quot;."/>
      <Parameter name="WINDOW_LENGTH" type="int" value="512" description="The length of the window."/>
    </Node>
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="-550.000000" y="-272.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="Length between a current frame and a next frame (in samples)."/>
      <Parameter name="USE_WAIT" type="bool" value="false" description="If true, wait as really recording."/>
    </Node>
    <Node name="node_WhiteNoiseAdder_1" type="WhiteNoiseAdder" x="-724.000000" y="170.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The size of window length."/>
      <Parameter name="WN_LEVEL" type="subnet_param" value="WN_LEVEL" description="An amplitude of white noise."/>
    </Node>
    <Node name="node_SpectralGainFilter_1" type="SpectralGainFilter" x="-85.000000" y="54.000000"/>
    <Node name="node_HRLE_1" type="HRLE" x="-355.000000" y="-27.000000">
      <Parameter name="LX" type="subnet_param" value="LX" description="Lx value of estimation, e.g. Lx=0 -&gt; Minimum (MCRA), Lx=0.5 -&gt; Median , Lx=1.0 -&gt; Maximum [default:0.85]"/>
      <Parameter name="TIME_CONSTANT" type="float" value="16000" description="Time constant for exponential decay window in samples [default:16000]"/>
      <Parameter name="NUM_BIN" type="float" value="2000" description="Number of histogram bins [default:1000]"/>
      <Parameter name="MIN_LEVEL" type="float" value="-200" description="Minimum level of histogram bin in dB [default:-100]"/>
      <Parameter name="STEP_LEVEL" type="float" value="0.5" description="Step level of histogram bin (Width of each histogram bin) in dB [default:0.2]"/>
      <Parameter name="DEBUG" type="bool" value="false" description="Prints the histogram for each 100 iterations."/>
    </Node>
    <Node name="node_CalcSpecSubGain_1" type="CalcSpecSubGain" x="-570.000000" y="69.000000">
      <Parameter name="ALPHA" type="float" value="1.0" description="Overestimation factor."/>
      <Parameter name="BETA" type="float" value="0.0" description="Spectral floor."/>
      <Parameter name="SS_METHOD" type="int" value="2" description="1: Magnitude Spectral Subtraction, 2: Power SS"/>
    </Node>
    <Node name="node_PowerCalcForMap_1" type="PowerCalcForMap" x="-507.000000" y="-77.000000">
      <Parameter name="POWER_TYPE" type="string" value="POW" description="Measure for computing the POW or MAG (i.e. power or magnitude) of the complex spectrum [default: POW]"/>
    </Node>
    <Node name="node_Synthesize_3" type="Synthesize" x="-569.000000" y="170.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The length between a frame and a previous frame."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)"/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be RECTANGLE, CONJ, or HAMMING."/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1.0" description="Output gain which is multiplied to the output of the waveform."/>
    </Node>
    <Node name="node_GHDSS_1" type="GHDSS" x="-675.000000" y="-77.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="0" description="Lower bound of frequency (Hz). [default: 0]"/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="8000" description="Upper bound of frequency (Hz). [default: 8000]"/>
      <Parameter name="TF_CONJ_FILENAME" type="subnet_param" value="TF_CONJ" description="Filename of a pre-measured transfer function for separation."/>
      <Parameter name="INITW_FILENAME" type="string" value="" description="Filename of an initial separation matrix. If specified, a matrix in INITW_FILENAME is used as an initial separation matrix. Otherwise, initial separation matrix is estimated from the geometrical relationship or pre-measured TF according to TF_CONJ."/>
      <Parameter name="SS_METHOD" type="string" value="ADAPTIVE" description="The calculation method for SS step size parameter corresponding to the blind separation part. &quot;FIX&quot; uses a fixed step size,&quot;LC_MYU&quot; uses the same value as LC_MYU, and &quot;ADAPTIVE&quot; adaptively estimates an optimal step size. [default: FIX]"/>
      <Parameter name="SS_SCAL" type="float" value="1.0" description="Scaling factor for SS step size. [default: 1.0]"/>
      <Parameter name="SS_MYU" type="float" value="0.001" description="SS step size value. [default 0.001]"/>
      <Parameter name="NOISE_FLOOR" type="float" value="0.0" description="Noise floor value. [default 0.0]"/>
      <Parameter name="LC_CONST" type="string" value="FULL" description="The calculation method for geometric constraints. &quot;FULL&quot; uses all elements of a matrix, and &quot;DIAG&quot; only uses diagonal parts. [default: FULL]"/>
      <Parameter name="LC_METHOD" type="string" value="ADAPTIVE" description="The calculation method for LC step size corresponding to geometric constraints. &quot;FIX&quot; uses a fixed value, and &quot;Adaptive&quot; adaptively estimates an optimal step size. [default: FIX]"/>
      <Parameter name="LC_MYU" type="float" value="0.001" description="LC step size value. [default 0.001]"/>
      <Parameter name="UPDATE_METHOD_TF_CONJ" type="string" value="POS" description="Switching method of TF_CONJ data. [default: POS]"/>
      <Parameter name="UPDATE_METHOD_W" type="string" value="ID_POS" description="Switching method of separation matrix, W. [default: ID]"/>
      <Parameter name="UPDATE_SEARCH_AZIMUTH" type="float" value="" description="Angle of azimuth allowance to serch TF or separation matrix in degree. [default: ]"/>
      <Parameter name="UPDATE_SEARCH_ELEVATION" type="float" value="" description="Angle of elevation allowance to serch TF or separation matrix in degree. [default: ]"/>
      <Parameter name="UPDATE_ACCEPT_ANGLE" type="float" value="5.0" description="Angle allowance to switch separation matrix in degree. available when when UPDATE_METHOD_W is POS or ID_POS. [default: 5.0]"/>
      <Parameter name="EXPORT_W" type="bool" value="false" description="Separation matrix W is exported if true. [default: false]"/>
      <Parameter name="EXPORT_W_FILENAME" type="string" value="" description="The filename to export W."/>
      <Parameter name="UPDATE" type="string" value="STEP" description="The update method of separation matrix. &quot;STEP&quot; updates W sequentially, i.e., based on SS and then on LC cost. &quot;TOTAL&quot; updates W based on an integrated value of SS and LC cost [default: STEP]"/>
    </Node>
    <Node name="node_EstimateLeak_1" type="EstimateLeak" x="-350.000000" y="-77.000000">
      <Parameter name="LEAK_FACTOR" type="float" value="0.25" description="Leak factor [default:0.25]"/>
      <Parameter name="OVER_CANCEL_FACTOR" type="float" value="1" description="Over cancel value [default:1]"/>
    </Node>
    <Node name="node_CalcSpecAddPower_2" type="CalcSpecAddPower" x="-64.000000" y="-70.000000"/>
    <Node name="node_LocalizeMUSIC_1" type="LocalizeMUSIC" x="-571.000000" y="-182.000000">
      <Parameter name="MUSIC_ALGORITHM" type="string" value="SEVD" description="Sound Source Localization Algorithm. If SEVD, NOISECM will be ignored"/>
      <Parameter name="TF_CHANNEL_SELECTION" type="object" value="&lt;Vector&lt;int&gt; 0 1 2 3 4 5 6 7&gt;" description="Microphone channels for localization"/>
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="A_MATRIX" description="Filename of a transfer function matrix."/>
      <Parameter name="WINDOW" type="int" value="50" description="The number of frames used for calculating a correlation function."/>
      <Parameter name="WINDOW_TYPE" type="string" value="FUTURE" description="Window selection to accumulate a correlation function. If PAST, the past WINDOW frames from the current frame are used for the accumulation. If MIDDLE, the current frame will be the middle of the accumulated frames. If FUTURE, the future WINDOW frames from the current frame are used for the accumulation. FUTURE is the default from version 1.0, but this makes a delay since we have to wait for the future information. PAST generates a internal buffers for the accumulation, which realizes no delay for localization."/>
      <Parameter name="PERIOD" type="int" value="50" description="The number of frames used for calculating a correlation matrix. [default: 50]"/>
      <Parameter name="NUM_SOURCE" type="subnet_param" value="NUM_SOURCE" description="Number of sources, which should be less than NB_CHANNELS [default: 2]."/>
      <Parameter name="MIN_DEG" type="int" value="-180" description="Minimum source direction to localize in degree. [default: -180]"/>
      <Parameter name="MAX_DEG" type="int" value="180" description="Maximum source direction to localize in degree. [default: 180]"/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="500" description="Lower bound of frequency (Hz) used for correlation matrix calculation. [default: 500]"/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="2800" description="Upper bound of frequency (Hz) used for correlation function matrix. [default: 2800]"/>
      <Parameter name="SPECTRUM_WEIGHT_TYPE" type="string" value="Uniform" description="MUSIC spectrum weight for each frequency bin."/>
      <Parameter name="A_CHAR_SCALING" type="float" value="1.0" description="Scaling factor of the A-Weight with respect to frequency"/>
      <Parameter name="MANUAL_WEIGHT_SPLINE" type="object" value="&lt;Matrix&lt;float&gt; &lt;rows 2&gt; &lt;cols 5&gt; &lt;data 0.0 2000.0 4000.0 6000.0 8000.0 1.0 1.0 1.0 1.0 1.0&gt; &gt;" description="MUSIC spectrum weight for each frequency bin. This is a 2 by M matrix. The first row represents the frequency, and the second row represents the weight gain. &quot;M&quot; represents the number of key points for the spectrum weight. The frequency range between M key points will be interpolated by spline manner. The format is &quot;&lt;Matrix&lt;float&gt; &lt;rows 2&gt; &lt;cols 2&gt; &lt;data 1 2 3 4&gt; &gt;&quot;."/>
      <Parameter name="MANUAL_WEIGHT_SQUARE" type="object" value="&lt;Vector&lt;float&gt; 0.0 2000.0 4000.0 6000.0 8000.0&gt;" description="MUSIC spectrum weight for each frequency bin. This is a M order vector. The element represents the frequency points for the square wave. &quot;M&quot; represents the number of key points for the square wave weight. The format is &quot;&lt;Vector&lt;float&gt; 1 2 3 4&gt;&quot;."/>
      <Parameter name="ENABLE_EIGENVALUE_WEIGHT" type="bool" value="true" description="If true, the spatial spectrum is weighted depending on the eigenvalues of a correlation matrix. We do not suggest to use this function with GEVD and GSVD, because the NOISECM changes the eigenvalue drastically. Only useful for SEVD."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If true, output sound localization results to standard output. [default: false]"/>
    </Node>
    <Node name="node_SourceTracker_1" type="SourceTracker" x="-420.000000" y="-182.000000">
      <Parameter name="THRESH" type="subnet_param" value="THRESH" description="Power threshold for localization results. A localization result with higher power than THRESH is tracked, otherwise ignored."/>
      <Parameter name="PAUSE_LENGTH" type="float" value="800" description="Life duration of source in ms. When any localization result for a source is found for more than PAUSE_LENGTH / 10 iterations, the source is terminated. [default: 800]"/>
      <Parameter name="MIN_SRC_INTERVAL" type="float" value="20" description="Source interval threshold in degree. When the angle between a localization result and a source is smaller than MIN_SRC_INTERVAL, the same ID is given to the localization result. [default: 20]"/>
      <Parameter name="MIN_ID" type="int" value="0" description="Minimum ID of source locations. MIN_ID should be greater than 0 or equal."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Output debug information if true [default: false]"/>
    </Node>
    <Node name="node_SourceIntervalExtender_1" type="SourceIntervalExtender" x="-172.000000" y="-182.000000">
      <Parameter name="PREROLL_LENGTH" type="int" value="50" description="Preroll length in frame. [default: 50]"/>
    </Node>
    <Node name="node_PreEmphasis_1" type="PreEmphasis" x="-432.000000" y="170.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="window length in sample [default: 512]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate in Hz [default: 16000]"/>
      <Parameter name="PREEMCOEF" type="float" value="0.97" description="pre-emphasis coefficient [default: 0.97]"/>
      <Parameter name="INPUT_TYPE" type="string" value="WAV" description="The domain to perform pre-emphasis [default: WAV]"/>
    </Node>
    <Node name="node_MultiFFT_2" type="MultiFFT" x="-318.000000" y="170.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="FFT length in sample. [default: 512]"/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE. [default: CONJ]"/>
      <Parameter name="WINDOW_LENGTH" type="int" value="512" description="Window length of the window function. [default: 512]"/>
    </Node>
    <Node name="node_WhiteNoiseAdder_2" type="WhiteNoiseAdder" x="-191.000000" y="170.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="WN_LEVEL" type="float" value="0" description="An amplitude of white noise to be added. [default: 0]"/>
    </Node>
    <Node name="node_MelFilterBank_1" type="MelFilterBank" x="-52.000000" y="170.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate in Hz.  [default: 16000]"/>
      <Parameter name="CUTOFF" type="int" value="8000" description="Cutoff frequency in Hz. Mel-filterbanks are placed between 0 Hz and CUTOFF Hz. [default: 8000]"/>
      <Parameter name="MIN_FREQUENCY" type="int" value="63" description="Minimum frequency (Hz) [default: 63]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="8000" description="Maximum frequency (Hz) [default: 8000]"/>
      <Parameter name="FBANK_COUNT" type="int" value="13" description="The number of Mel filter banks. [default: 13]"/>
    </Node>
    <Node name="node_MSLSExtraction_1" type="MSLSExtraction" x="-586.000000" y="263.000000">
      <Parameter name="FBANK_COUNT" type="int" value="13" description="Size of the static part of MSLS feature vector. [default: 13]"/>
      <Parameter name="NORMALIZATION_MODE" type="string" value="CEPSTRAL" description="The domain to perform normalization. CEPSTRAL or SPECTRAL. [default: CEPSTRAL]"/>
      <Parameter name="USE_POWER" type="bool" value="true" description="Use power feature if true. [default: false]"/>
    </Node>
    <Node name="node_Delta_1" type="Delta" x="-464.000000" y="263.000000">
      <Parameter name="FBANK_COUNT" type="int" value="14" description="The size of the input feature vector."/>
    </Node>
    <Node name="node_FeatureRemover_1" type="FeatureRemover" x="-339.000000" y="263.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 13 &gt;" description="Component indices in a feature vector to remove. E.g. &lt;Vector&lt;int&gt; 13&gt; to remove 14th comopnent (The index start with 0)."/>
    </Node>
    <Node name="node_SpeechRecognitionSMNClient_1" type="SpeechRecognitionSMNClient" x="-376.000000" y="418.000000">
      <Parameter name="MFM_ENABLED" type="bool" value="false" description="MFM is enbaled if true. [default: true]"/>
      <Parameter name="HOST" type="string" value="127.0.0.1" description="Hostname or IP of Julius/Julian server. [default: 127.0.0.1]"/>
      <Parameter name="PORT" type="int" value="5530" description="Port number of Julius/Julian server. [default: 5530]"/>
      <Parameter name="SOCKET_ENABLED" type="bool" value="true" description="send data via socket if true. [default: true]"/>
    </Node>
    <Node name="node_DisplayLocalization_1" type="DisplayLocalization" x="144.000000" y="-182.000000">
      <Parameter name="WINDOW_NAME" type="string" value="Source Location" description="Window name of the time-azimuth map [default: Window name]"/>
      <Parameter name="WINDOW_LENGTH" type="int" value="1000" description="Window length to show at the same time [sample]"/>
      <Parameter name="VERTICAL_RANGE" type="object" value="&lt;Vector&lt;int&gt; -180 180&gt;" description="Plot range of the vertical axis"/>
      <Parameter name="PLOT_TYPE" type="string" value="AZIMUTH" description="Coordinate setting for the plotting"/>
    </Node>
    <Node name="node_Synthesize_1" type="Synthesize" x="103.000000" y="54.000000">
      <Parameter name="LENGTH" type="int" value="512" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, or RECTANGLE. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1.0" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_Synthesize_2" type="Synthesize" x="106.000000" y="-100.000000">
      <Parameter name="LENGTH" type="int" value="512" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, or RECTANGLE. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1.0" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_SaveWavePCM_1" type="SaveWavePCM" x="120.000000" y="137.000000">
      <Parameter name="BASENAME" type="string" value="wav/WN" description="Basename of WAVE files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int16" description="Bit format of samples. 16 and 24 bits are supported."/>
    </Node>
    <Node name="node_SaveWavePCM_2" type="SaveWavePCM" x="230.000000" y="54.000000">
      <Parameter name="BASENAME" type="string" value="wav/NR" description="Basename of WAVE files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int16" description="Bit format of samples. 16 and 24 bits are supported."/>
    </Node>
    <Node name="node_SaveWavePCM_3" type="SaveWavePCM" x="255.000000" y="-100.000000">
      <Parameter name="BASENAME" type="string" value="wav/GHDSS" description="Basename of WAVE files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int16" description="Bit format of samples. 16 and 24 bits are supported."/>
    </Node>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_CalcSpecSubGain_1" output="GAIN" to="node_SpectralGainFilter_1" input="GAIN"/>
    <Link from="node_PowerCalcForMap_1" output="OUTPUT" to="node_HRLE_1" input="INPUT_SPEC"/>
    <Link from="node_SpectralGainFilter_1" output="OUTPUT_SPEC" to="node_WhiteNoiseAdder_1" input="INPUT">-24 54 -24 107 -782 107 -782.5 170 </Link>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_GHDSS_1" input="INPUT_FRAMES">1.5 -279 2 -136 -811 -136 -811 -84.5 </Link>
    <Link from="node_CalcSpecSubGain_1" output="VOICE_PROB" to="node_SpectralGainFilter_1" input="VOICE_PROB"/>
    <Link from="node_CalcSpecAddPower_2" output="OUTPUT_POWER_SPEC" to="node_CalcSpecSubGain_1" input="NOISE_SPEC">0.5 -70 1 -13 -829 -13 -829 77 -760 76.5 </Link>
    <Link from="node_WhiteNoiseAdder_1" output="OUTPUT" to="node_Synthesize_3" input="INPUT"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_LocalizeMUSIC_1" input="INPUT">1.5 -279 2 -226 -622 -226 -622.5 -182 </Link>
    <Link from="node_LocalizeMUSIC_1" output="OUTPUT" to="node_SourceTracker_1" input="INPUT"/>
    <Link from="node_SourceTracker_1" output="OUTPUT" to="node_SourceIntervalExtender_1" input="SOURCES"/>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_GHDSS_1" input="INPUT_SOURCES">-95.5 -182 -95 -112 -851 -112 -851 -69 -811 -69.5 </Link>
    <Link from="node_PreEmphasis_1" output="OUTPUT" to="node_MultiFFT_2" input="INPUT"/>
    <Link from="node_MultiFFT_2" output="OUTPUT" to="node_WhiteNoiseAdder_2" input="INPUT"/>
    <Link from="node_WhiteNoiseAdder_2" output="OUTPUT" to="node_MelFilterBank_1" input="INPUT"/>
    <Link from="node_MelFilterBank_1" output="OUTPUT" to="node_MSLSExtraction_1" input="FBANK">-4 170 -4 224 -715 224 -715 255.5 </Link>
    <Link from="node_WhiteNoiseAdder_2" output="OUTPUT" to="node_MSLSExtraction_1" input="SPECTRUM">-132.5 170 -132 208 -759 208 -759 271 -715 270.5 </Link>
    <Link from="node_MSLSExtraction_1" output="OUTPUT" to="node_Delta_1" input="INPUT"/>
    <Link from="node_Delta_1" output="OUTPUT" to="node_FeatureRemover_1" input="INPUT"/>
    <Link from="node_FeatureRemover_1" output="OUTPUT" to="node_SpeechRecognitionSMNClient_1" input="FEATURES">-281 263 -285 333 -548 333 -548 403 </Link>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_SpeechRecognitionSMNClient_1" input="SOURCES">-91 -182 42 -182 42 475 -548 475 -548 433 </Link>
    <Link from="node_FeatureRemover_1" output="OUTPUT" to="node_SpeechRecognitionSMNClient_1" input="MASKS">-281 263 -285 374 -602 374 -602 418 -548 418 </Link>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_DisplayLocalization_1" input="SOURCES"/>
    <Link from="node_Synthesize_3" output="OUTPUT" to="node_PreEmphasis_1" input="INPUT"/>
    <Link from="node_GHDSS_1" output="OUTPUT" to="node_PowerCalcForMap_1" input="INPUT"/>
    <Link from="node_GHDSS_1" output="OUTPUT" to="node_SpectralGainFilter_1" input="INPUT_SPEC">-647 -77 -519 39 -232 39 </Link>
    <Link from="node_PowerCalcForMap_1" output="OUTPUT" to="node_EstimateLeak_1" input="INPUT_POWER_SPEC"/>
    <Link from="node_EstimateLeak_1" output="LEAK_POWER_SPEC" to="node_CalcSpecAddPower_2" input="INPUT_POWER_SPEC1"/>
    <Link from="node_HRLE_1" output="NOISE_SPEC" to="node_CalcSpecAddPower_2" input="INPUT_POWER_SPEC2"/>
    <Link from="node_PowerCalcForMap_1" output="OUTPUT" to="node_CalcSpecSubGain_1" input="INPUT_POWER_SPEC">-446 -77 -446 14 -760 14 -760 61.5 </Link>
    <Link from="node_SpectralGainFilter_1" output="OUTPUT_SPEC" to="node_Synthesize_1" input="INPUT"/>
    <Link from="node_GHDSS_1" output="OUTPUT" to="node_Synthesize_2" input="INPUT">-647 -77 -611 -100 68.5 -100 </Link>
    <Link from="node_Synthesize_3" output="OUTPUT" to="node_SaveWavePCM_1" input="INPUT">-531.5 170 -507 137 70.5 137 </Link>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_SaveWavePCM_2" input="INPUT"/>
    <Link from="node_Synthesize_2" output="OUTPUT" to="node_SaveWavePCM_3" input="INPUT"/>
    <NetInput name="INPUT" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetOutput name="ASR" node="node_SpeechRecognitionSMNClient_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as SOURCES."/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetOutput name="SAVE_SEP_GHDSS" node="node_SaveWavePCM_3" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <NetOutput name="SAVE_SEP_WN" node="node_SaveWavePCM_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <NetOutput name="SAVE_SEP_NOISE_REDUCTION" node="node_SaveWavePCM_2" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <NetOutput name="OUTPUT" node="node_DisplayLocalization_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as input."/>
  </Network>
  <Parameter name="string:ARG3" type="" value=""/>
  <Parameter name="string:ARG2" type="" value=""/>
  <Parameter name="ARG1" type="string" value="ASIMOf114sma_alpha14long.wav"/>
</Document>
