#!/bin/sh

DATA="../data"
CONF="../config"

# check whether a kinect is correctly set or not
num_todo=$(grep TODO demoOnlineKinect.n | wc -l);
if [ ${num_todo} -gt 0 ];
then
		sound_card=$(cat /proc/asound/cards | grep Kinect | cut -c 2-2);
		echo "****************************************";
		echo "ERROR: no kinect specified. "
		echo "       To see device id, do";
		echo "       [>cat /proc/asound/cards]"
		printf "Device name might be \"plughw:"${sound_card};
		printf ",x\"\n";
		printf "       such as \"plughw:"${sound_card};
		printf ",0\", \"plughw:"${sound_card};
		printf ",1\",...\n";
		echo "****************************************";
		exit;
fi

echo "perform sound source separation without post-processing";
./demoOnlineKinect.n  ${CONF}/kinect_loc.dat ${CONF}/kinect_sep.tff

echo "To check the separated sound, audacity or wavesurfer can be used";